﻿using ProjectSeaplane.Entities;
using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;

namespace ProjectSeaplane.Drawings;

public static class ExtentionDrawingPlane
{
    private static readonly string _separatorForObject = ":";

    public static DrawingPlane? CreateDrawningPlane(this string info)
    {
        string[] strs = info.Split(_separatorForObject);
        EntityPlane? plane = EntitySeaplane.CreateEntitySeaplane(strs);
        if (plane != null)
        {
            return new DrawingSeaplane((EntitySeaplane)plane);
        }
        plane = EntityPlane.CreateEntityPlane(strs);
        if (plane != null)
        {
            return new DrawingPlane(plane);
        }
        return null;
    }

    public static string GetDataForSave(this DrawingPlane drawningCar)
    {
        string[]? array = drawningCar?.EntityPlane?.GetStringRepresentation();
        if (array == null)
        {
            return string.Empty;
        }
        return string.Join(_separatorForObject, array);
    }
}
