﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Runtime.InteropServices;
using System.Text;
using System.Threading.Tasks;

namespace ProjectSeaplane.Entities;

public class EntityPlane
{
    public int Speed { get; set; }

    public double Weight { get; set; }

    public Color BodyColor { get; private set; }
    public void setBodyColor(Color color)
    {
        BodyColor = color;
    }

    public double Step => Speed * 100 / Weight;

    public EntityPlane(int speed, double weight, Color bodyColor)
    {
        Speed = speed;
        Weight = weight;
        BodyColor = bodyColor;
    }

    public virtual string[] GetStringRepresentation()
    {
        return new[] { nameof(EntityPlane), Speed.ToString(), Weight.ToString(), BodyColor.Name };
    }

    public static EntityPlane? CreateEntityPlane(string[] strs)
    {
        if (strs.Length != 4 || strs[0] != nameof(EntityPlane))
        {
            return null;
        }
        return new EntityPlane(Convert.ToInt32(strs[1]), Convert.ToDouble(strs[2]), Color.FromName(strs[3]));
    }
}

