﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;

namespace ProjectSeaplane.Entities;
public class EntitySeaplane : EntityPlane
{
    public Color AdditionalColor { get; private set; }
    public void setAdditionalColor(Color color)
    {
        AdditionalColor = color;
    }

    public bool Floats { get; private set; }

    public bool InflatableBoat { get; private set; }

    public EntitySeaplane(int speed, double weight, Color bodyColor, Color additionalColor, bool floats, bool inflatableBoat) : base(speed, weight, bodyColor)
    {
        AdditionalColor = additionalColor;
        Floats = floats;
        InflatableBoat = inflatableBoat;
    }

    public override string[] GetStringRepresentation()
    {
        return new[] { nameof(EntitySeaplane), Speed.ToString(), Weight.ToString(), BodyColor.Name, AdditionalColor.Name,
                        Floats.ToString(), InflatableBoat.ToString()};
    }

    public static EntitySeaplane? CreateEntitySeaplane(string[] strs)
    {
        if (strs.Length != 7 || strs[0] != nameof(EntitySeaplane))
        {
            return null;
        }
        return new EntitySeaplane(Convert.ToInt32(strs[1]), Convert.ToDouble(strs[2]), Color.FromName(strs[3]),
                                    Color.FromName(strs[4]), Convert.ToBoolean(strs[5]), Convert.ToBoolean(strs[6]));
    }
}

